%% Decleare task structs
%Task1
task_1 = struct('center_gate', zeros(1,2),'tangent_gate',zeros(1,2));

%PathMarker 1
PM_1 = struct('waypoints',zeros(3,2));

%Task 2
Two_Sided = struct('position', zeros(1,2),'tangent_vec',zeros(1,2));
Three_Sided = struct('position',zeros(1,2),'init_tangent',zeros(1,2), 'rotation_speed',0);
task_2 = struct('TwoSided',Two_Sided, 'ThreeSided', Three_Sided);

%PathMarker2
PM_2 = struct('waypoints',zeros(3,2));

%Task 3
binClosed = struct('position',zeros(1,3));
binOpen = struct('position', zeros(1,3));
task_3 = struct('bin_closed', binClosed, 'bin_open', binOpen);

%Task4
top_ = struct('center_pos',zeros(1,3),'tangent',zeros(1,2));
bottom_ = struct('center_pos',zeros(1,3),'tangent',zeros(1,2));
task_4 = struct('top',top_, 'bottom',bottom_);

%Task5
task_5 = struct('octagon_pos',zeros(1,3),'vampire_pos', zeros(1,3));

%Resulting task struct
task_attr = struct('task1',task_1,'PM1',PM_1,'task2',task_2,'PM2', PM_2,'task3',task_3,'task4',task_4, 'task5',task_5);


%% Set values: 
%% Coordinates and vectors representing position and orientation of tasks

%Task 1: Enter Gate
task_attr.task1.center_gate = [2,4];
task_attr.task1.tangent_gate = [0.3,1];

% 1st path marker
task_attr.PM1.waypoints = [3.05 4.95; 3.5 5.4; 3.5 6]; %45 deg  

%Task 2: Touch buoys
%TwoSided
task_attr.task2.TwoSided.position = [4, 16];
task_attr.task2.TwoSided.tangent_vec = [0, 1];
%ThreeSided rotating
task_attr.task2.ThreeSided.position = [2.5, 16];
task_attr.task2.ThreeSided.init_tangent = [0, 1];
task_attr.task2.ThreeSided.rotation_speed = (5/60)*2*pi; %rad/sec

%2nd Path marker
task_attr.PM2.waypoints = [3.5 16.5; 3.5 17.13; 3.9445 17.575]; %45 deg 
 
%Task 3: Drop Markers in bin
%Closed Bin
task_attr.task3.bin_closed.position = [11.2, 24.6, 5];
%Open Bin
task_attr.task3.bin_open.position = [10.9, 25.2, 5];

%Task 4: Shoot Torpedos
%Upper part
task_attr.task4.top.center_pos = [ 10 8 3.9]; %z =(5-1.1)
task_attr.task4.top.tangent = [ -1 0];

%Lower part
task_attr.task4.bottom.center_pos = [ 10 8 4.55]; % z=5-0.45
task_attr.task4.top.tangent = [ -1 0];

%Task 5: Octagon
task_attr.task5.octagon_pos = [14 30 0];

%% Completed task struct
task_2_complete = struct('TwoSided', 0, 'ThreeSided',0);
task_3_complete = struct('open',0,'closed',0);
task_4_complete = struct('top', 0, 'bottom', 0);

%Resulting task_completed struct
task_completed = struct('Task1', 0, 'PathMarker1', 0, 'Task2', task_2_complete, 'PathMarker2', 0, ...
    'Task3', task_3_complete, 'Task4', task_4_complete, 'Task5', 0);


%% Hazards

stat_haz = struct('isStatic', 0, 'radius', 0,'position',[0 0]);
dyn_haz = struct('isDynamic',0,'posDetected',[0 0]);

static_hazard = struct('Dynamic',dyn_haz,'Static',stat_haz);

static_hazard.Static.isStatic = 1;
static_hazard.Static.radius = 0.3;
static_hazard.Static.position = [3.5 11];

dynamic_hazard = struct('Dynamic',dyn_haz,'Static',stat_haz);
dynamic_hazard.Dynamic.isDynamic = 1;
dynamic_hazard.Dynamic.posDetected = [6 20];
